local _G = _G;
local GetTime, GetNumGroupMembers, IsInRaid, IsInGroup  = GetTime, GetNumGroupMembers, IsInRaid, IsInGroup
local strsplit = strsplit
local GetSpellInfo, GetChannelName = GetSpellInfo, GetChannelName
local GetStatusBarTexture = GetStatusBarTexture
local UnitGUID, UnitHealthMax, UnitHealth = UnitGUID, UnitHealthMax, UnitHealth
local string, ipairs, tonumber, select = string, ipairs, tonumber, select
local table_insert, table_remove , table_getn = table.insert, table.remove, table.getn
local print, string_format, string_gmatch, string_length, string_sub, math_floor= print, string.format, string.gmatch, string.len, string.sub, math.floor
local SetValue, Show, SetText, Hide = SetValue, Show, SetText, Hide
local CreateFrame, CreateFontString = CreateFrame, CreateFontString
local SetStatusBarTexture, SetBackdrop, SetBackdropBorderColor, SetBackdropColor = SetStatusBarTexture, SetBackdrop, SetBackdropBorderColor, SetBackdropColor
local SetHorizTile, SetMinMaxValues, SetPoint, SetHeight, SetStatusBarColor, SetWidth = SetHorizTile, SetMinMaxValues, SetPoint, SetHeight, SetStatusBarColor, SetWidth
local SetFont = SetFont
local red = RED_FONT_COLOR
local StopMovingOrSizing = StopMovingOrSizing
local GREEN_FONT_COLOR = GREEN_FONT_COLOR
red.r, red.g, red.b = 0.75, 0.05 ,0.05
local UnrealTargets = CreateFrame('Frame', "UnrealTargets", UIParent)
local ColorPickerFrame = ColorPickerFrame

					
local UnrealTargets_options = {};
local targetframe = {}


function UnrealTargets:mysettings(arg1)
	--print (arg1.." loaded")
	if arg1 == "UnrealTargets" then
	   if not unrealtargetssettings then
			unrealtargetssettings = {
				['config'] = {
					['height'] = 30,
					['width'] = 175,
					['rafter_distance'] = 5,
					['posix'] = 1200,
					['posiy'] = 700,
					['barnamecut'] = 15,
					['castbarnamecut'] = 15,
					['color_r'] = 0.75,
					['color_g'] = 0.05,
					['color_b'] = 0.05,
					['color_a'] = 1,
					['debufficonsize'] = 19,
					['debufficonnumbersize'] = 11,
					['left'] = 5116,
					['right'] = 34914
				}
			}
			--print('ut 1')
		elseif unrealtargetssettings == nil then
			unrealtargetssettings  = {
				['config'] = {
					['height'] = 30,
					['width'] = 175,
					['rafter_distance'] = 5,
					['posix'] = 1200,
					['posiy'] = 700,
					['barnamecut'] = 15,
					['castbarnamecut'] = 15,
					['color_r'] = 0.75,
					['color_g'] = 0.05,
					['color_b'] = 0.05,
					['color_a'] = 1,
					['debufficonsize'] = 19,
					['debufficonnumbersize'] = 11,
					['left'] = 5116,
					['right'] = 34914
				}
			}
			--print('ut 2')
		else
			--print (unrealtargetssettings['config']['height'].." 45")
		end
	end
end

local unitdb = {}
unitdb.isinfight = false
unitdb.allunitguids = {}
unitdb.units = {}
unitdb.unitsmaxhp = {}
unitdb.slider = 0
unitdb.zone = true
unitdb.groupmembers = {}
unitdb.grouppets = {}
unitdb.groupids = {}
unitdb.targets = {}
unitdb.playertarget = 'nil'
unitdb.playermouseover = 'nil'
unitdb.playerfocus = 'nil'
unitdb.playertargetold = {}
unitdb.targetnumbers = {}
unitdb.playerdebuffs = {}
unitdb.debuffinfo = {}
local myunits = {}
myunits.castTime = 0

unitdb.friendlyunitids = { 'player'
	,'pet'
	,'party1'
	,'party2'
	,'party3'
	,'party4'
	,'raid1'
	,'raid2'
	,'raid3'
	,'raid4'
	,'raid5'
	,'raid6'
	,'raid7'
	,'raid8'
	,'raid9'
	,'raid10'
	,'raid11'
	,'raid12'
	,'raid13'
	,'raid14'
	,'raid15'
	,'raid16'
	,'raid17'
	,'raid18'
	,'raid19'
	,'raid20'
	,'raid21'
	,'raid22'
	,'raid23'
	,'raid24'
	,'raid25'
	,'raid26'
	,'raid27'
	,'raid28'
	,'raid29'
	,'raid30'
	,'raid31'
	,'raid32'
	,'raid33'
	,'raid34'
	,'raid35'
	,'raid36'
	,'raid37'
	,'raid38'
	,'raid39'
	,'raid40'
	

}

unitdb.ignorbuff = { 17 -- MAchtwort: Schild
	 ,65081 --Körper und Geist
	 ,184915 --Geistige Ermüdung
	 ,185104 --Geistige Ermüdung
}

unitdb.ignornpc = {47649 -- wildpilz
	,95582 -- Armee der toten
	,24207 -- Vogel
	,15439 -- Totem des Feuerelementars
	,29264 -- Geisterwolf
	,82521 -- Entweihen
	,3527 -- Totem des heilenden Flusses
	,60199 -- Rune der Macht
	,47243 -- Spiegelbild
	,59764 -- Totem der Heilungsflut
	,77789 -- Blingtron 5000
	,416 -- Wichtel
	,31216 -- Spiegelbild
	,5929 -- Totem des glühenden Magmas
	,93828 -- Trainingsattrappe
	,45322 -- Gefrorene Kugel
	,62982 -- Geistbeuger
	,61245 -- Totem der Energiespeicherung
	,54983 -- Treant
	,77934 -- Totem des Sturmelementars
	,77936 -- Großer Sturmelementar
	,55659 -- Wildwichtel
	,2523 -- Totem der Verbrennung
	,90610 -- Teufelsfeuermunition
	,78158 -- Verdammniswache
	,15438 -- Großer Feuerelementar
	,46490 -- Wächter der Uralten Könige
	,53006 -- Totem der Geistverbindung
	,59000 -- Terrorwache
	,47319 -- Gezielter Sprung
	,60849 -- Statue der Jadeschlange
	,92993 -- Spiegelbild
	,63508 -- Xuen
	,92624 -- Streitkolben
	,76168 -- Verheerer
	,92587 -- Schwert
	,92919 -- Restenergie
	,76933 -- Kristallprisma
	,11859 -- Verdammniswache
	,27893 -- Runenklinge
	,73967 -- Xuen
	,61146 -- Statue des Schwarzen Ochsen
	,35642 -- Jeeves
	,94729 -- Kohlenbecken des Erwachens
	,59607 -- Spektralerscheinung
	,59712 -- Totem des Steinbollwerks
	,96115 -- Schlachtstandarte von Vol'jins Kopfjägern
	,94852 -- Feenmondschwinge
	,19668 -- Schattengeist
	,89194 -- Ausgedörrte Echse
	,94922 -- Lady Jaina Prachtmeer
	,94946 -- Arthas Menethil
	,94879 -- Tyrande Wisperwind
	,92893 -- Axt
	,94925 -- Fürstin Sylvanas Windläufer
	,77726 -- Schattenreflexion
	,27829 -- Schwarzer Gargoyle
	,54569 -- Transzendenzgeist
	,76917 -- <Persönliches Hologramm>
	,5925 -- Totem der Erdung
	,15352 -- Großer Erdelementar
	,15430 -- Totem des Erdelementars
	,61029 -- Urfeuerelementar
	,60561 -- Totem des Erdgriffs
	,64571 -- Lichtbrunnen
	,61056 -- Urerdelementar
	,40703 -- Megazord
	,91326 -- Gul'dan
	,59717 -- Totem des Windwandelns
	,5913 -- Totem des Erdstoßes
	,92208 -- Verdammnisfeuergeist
	,59738 -- Hammer des Lichts
	,4277 -- Auge von Kilrogg
	,67235 -- Schattengeist
	,80302 -- Wächterkugel
	,86945 -- Hexenmeisterin von Haus Sonnenschwur
	,89 -- Höllenbestie
	,86933 -- Magierin des Kriegsspeers
	,69680 -- Sturmgeist
	,58542 -- Vergangenes Selbst
	 ,88380 -- Grunzerin
	,88393 -- Grunzerin
	,88391 -- Garnisonsschütze
	,67236 -- Geistbeuger
	,95455 -- Verderbter urzeitlicher Obelisk
	,88435 -- Wächter der Schmiede
	,78215 -- Verirorok
	,61711 -- Wassertotem
	,61714 -- Lufttotem
	,61713 -- Erdtotem
	,69792 -- Erdgeist
	,77942 -- Ursturmelementar
	,87061 -- Schattengeist
	,88050 -- allunitguids
	,31897 -- Lichtbrunnen
	,86946 -- Ausgestoßener Krallenpriester
	,62182 -- Amethystschieferjungtier
	,86964 -- Erdbinder der Blutmähnen
	,58997 -- Abyssal
	,86682 -- Pensionierter gorianischer Zenturio
	,69791 -- Feuergeist
	,59390 -- Spottendes Banner
	,48638 -- Schlachtstandarte der Gilde
	,84774 -- Tödliche Eisenfalle
	,83925 -- Eisenfalle
	,44199 -- Ring des Frosts
	,77894 -- Walter
	,95468 -- Satyr der Illidari
	,95469 -- Bösartiger Höllenhund
	,86951 -- Wolf aus Nagrand
	,86187 -- Tier
	,65282 -- Leerententakel
	,61712 -- Feuertotem
	,56194 -- Spinnenjungtier
	,90206 -- Schwester der Versuchung
	,93247 -- Dämonenportal
	,62005 -- Tier
	,33239 -- El Jonathanxd
	,86702 -- Verweilender Geist
	,59271 -- Dämonisches Tor
	--,94924 -- Eiserner Peon
	,81032 -- Croman
	,86180 -- Tier
	,86181 -- Tier
	,78001 -- Totem des Wolkenbruchs
	,1964 -- Treant
	,2630 -- Totem der Erdbindung
	,88054 -- Saberonleibwächter
	,88060 -- Wütender Zwicky
	,19921 -- Viper
	,10933 -- Giftige Schlange
	,80703 -- Totem des Windzorns
}

-- 90432 FAIL	

local db = {}
db.silencespells = {
	-- dk
	47476 -- strangulate
	-- druid
	,114237 -- glyph-of-fae-silence
	,78675 -- solar-beam
	-- mage
	,102051 -- frostjaw
	-- paladin
	,31935 -- avengers-shield
	-- priest
	,15487 -- silence
	-- rogue
	,703 -- garrote
	-- bloddelf racial
	,28730 -- arcane-torrent
	,50613 -- arcane-torrent
	,25046 -- arcane-torrent
	,155145 -- arcane-torrent
	,129597 -- arcane-torrent
	,69179 -- arcane-torrent
	,80483 -- arcane-torrent
}
db.stunspells = {
	-- dk
	108194 -- asphyxiate
	,91800 -- gnaw
	,47481 -- gnaw
	,91797 -- monstrous-blow
	,108200 -- remorseless-winter
	-- druid
	,22570 -- maim
	,5211 -- mighty-bash
	,1822 -- rake
	-- hunter
	,109248 -- binding-shot
	,19577 -- intimidation
	-- mage
	,44572 -- deep-freeze
	-- monk
	,119392 -- charging-ox-wave
	,113656 -- fists-of-fury
	,119381 -- leg-sweep
	-- paladin
	,853 -- hammer-of-justice
	,105593 -- fist-of-justice
	,119072 -- holy-wrath
	--rogue
	,1833 -- cheap-shot
	,408 -- kidney-shot
	-- shaman
	,80313 -- pulverize
	,108269 -- capacitor-totem
	,118905 -- static-charge
	-- warlock
	,89766 -- axe-toss
	,30283 -- shadowfury
	,1122 -- summon-infernal
	,112921 -- summon-abyssal
	-- warrior
	,46968 -- shockwave
	,107570 -- storm-bolt
	-- tauren racial
	,20549 -- war-stomp
}
db.incapacitatesspells = { --handlungsunfähig
	-- druid
	99 -- incapacitating-roar
	-- hunter
	,1499 -- freezing-trap
	,19386 -- wyvern-sting
	-- mage
	,118 -- polymorph sheep
	,28271-- polymorph turtle
	,28272 -- polymorph pig
	,61305 -- polymorph black cat
	,61721 -- polymorph rabbit
	,61780 -- polymorph pig 2
	,161353 -- polymorph polar bear cup
	,161354 -- polymorph monkey
	,161355 -- polymorph penguin
	,161372 -- polymorph turtle 2 
	,113724 -- ring-of-frost
	,82691 -- ring-of-frost
	,96369 -- ring-of-frost
	,140384 -- ring-of-frost
	-- monk
	,123394 -- glyph-of-breath-of-fire
	,115078 -- paralysis
	,116844 -- ring-of-peace
	-- paladin
	,20066 -- repentance
	-- priest
	,605 -- dominate-mind
	,88625 -- holy-word-chastise
	,64044 -- psychic-horror
	,9484 -- shackle-undead
	-- rogue
	,1776 -- gouge
	,6770 -- sap
	-- shaman
	,51514 -- hex
	-- warlock
	,710 -- banish
	,111397 -- blood-horror
	,6789 -- mortal-coil
	-- pandaren racial
	,107079 -- quaking-palm
}
db.disorientsspells = {
	--druid
	33786 -- cyclone
	-- mage
	,31661 -- dragons-breath
	-- paladin
	,115750 -- blinding-light
	,10326 -- turn-evil
	-- priest
	,8122 -- psychic-scream
	-- rogue
	,2094 -- blind
	-- warlock
	,5782 -- fear
	,130616 -- fear
	,118699 -- fear
	,5484 -- howl-of-terror
	,115268 -- mesmerize
	,6358 -- seduction
	-- warrior
	,5246 -- intimidating-shout
}	

	
function cmdut(arg)
	if arg == "test" then
		local name, _, icon, _, _, duration, expirationTime, unitCaster, _, _, spellId = UnitDebuff('target', 1)
		unitCaster = unitCaster or 0
		name = name or 'noone'
		print(name..' from '..unitCaster)
	elseif  arg == "test2" then
		theframe:SetBackdropColor(1, 1, 0)
	elseif  arg == "reset" then
		
		UnrealTargets:reset_frames()
	end	
end

function UnrealTargets:interrupt()
	myunits.bar = UnrealTargets:set_hp_frame(0, 0, 'mytestbar', UiParent)
	local testheightbar = 33
	local testwidthbar = 200
	myunits.bar:SetWidth(testwidthbar)
	myunits.bar:SetHeight(testheightbar)
	myunits.fontname = myunits.bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	myunits.fontname:SetPoint("TOPLEFT", 0, 0)
	local targetname = UnrealTargets:cut_name('Interrupt')
	myunits.fontname:SetText(targetname)
	myunits.fontname:SetFont("Fonts\\FRIZQT__.ttf",testheightbar*20/33,"OUTLINE")
	myunits.fonthppercent = myunits.bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	myunits.fonthppercent:SetPoint("TOPRIGHT", 0, 0)
	myunits.fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",testheightbar*20/33,"OUTLINE")	
	myunits.bar:SetMovable(true)
	myunits.bar:EnableMouse(true)
	myunits.bar:RegisterForDrag("LeftButton")
	myunits.bar:SetScript("OnDragStart", myunits.bar.StartMoving)
	myunits.bar:SetScript("OnDragStop", myunits.bar.StopMovingOrSizing)
	myunits.castbar = UnrealTargets:set_hp_frame(0, -testheightbar/3, 'mytestbarcastline', myunits.bar)
	myunits.castbar:SetWidth(testwidthbar)
	myunits.castbar:SetHeight(testheightbar/3)
	local green = GREEN_FONT_COLOR 
	myunits.castbar:SetStatusBarColor(green.r, green.g, green.b)
	myunits.castbar:Hide()
	local icon = select(3,GetSpellInfo(740))
	myunits.icon = CreateFrame("StatusBar", 'mytestbaricon', myunits.bar)
	myunits.icon:SetStatusBarTexture(icon)
	myunits.icon:SetWidth(testheightbar)
	myunits.icon:SetHeight(testheightbar)
	myunits.icon:SetPoint("Topleft", -testheightbar, 0)
	myunits.icon:Hide()
end

function UnrealTargets:option_slider(name, uiparent, anocher, posix, posiy, minvale, maxvalue, titlename, databasevalue, valuestep) 
	valuestep = valuestep or 1
	local slider = CreateFrame("Slider", name ,uiparent,"OptionsSliderTemplate")
	slider:SetPoint(anocher, posix, posiy)
	slider.textLow = _G[name.."Low"]
	slider.textHigh = _G[name.."High"]
	slider.text = _G[name.."Text"]
	slider:SetMinMaxValues(minvale, maxvalue)
	slider.textLow:SetText(minValue)
	slider.textHigh:SetText(maxValue)
	slider.text:SetText(titlename)
	slider:SetValue(databasevalue)
	slider:SetValueStep(1)
	-- if valuestep ~= 1 then
		-- minvale = minvale*valuestep
		-- maxvalue = maxvalue*valuestep
	-- end
	-- slider.textLow:SetText(minValue)
	-- slider.textHigh:SetText(maxValue)
	
	slider.editBox = CreateFrame("EditBox", "edittest"..name, slider, "InputBoxTemplate")
	slider.editBox:SetWidth(30)
	slider.editBox:SetHeight(8)
	slider.editBox:SetBackdropColor(0, 0, 0, 0.8)
	slider.editBox:SetBackdropBorderColor(0.6, 0.6, 0.6, 1)
	slider.editBox:SetPoint("Topleft", 62, -20)
	slider.editBox:ClearFocus(self)
	slider.editBox:SetAutoFocus(false)	
	return slider
end

function UnrealTargets:option_editbox(name, uiparent, anocher, posix, posiy, width, height, titlename, databasevalue) 
	
	local editBox = CreateFrame("EditBox", "edittest"..name, uiparent, "InputBoxTemplate")
	editBox:SetText(titlename)
	editBox:SetWidth(width)
	editBox:SetHeight(height)
	editBox:SetBackdropColor(0, 0, 0, 0.8)
	editBox:SetBackdropBorderColor(0.6, 0.6, 0.6, 1)
	editBox:SetPoint(anocher, posix, posiy)
	editBox:ClearFocus(self)
	editBox:SetAutoFocus(false)	
	return editBox
end

function round(num, ...)
	local idp = ... or 0
	local mult = 10^(idp or 0)
	return math_floor(num * mult + 0.5) / mult
end

function UnrealTargets:set_hp_frame(posix, posiy, ...)
	local framename, myuiparent = ... or nil, UiParent
	local NewStatusBar = CreateFrame("StatusBar", framename, myuiparent)
	NewStatusBar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	NewStatusBar:SetBackdrop({
				bgFile = "Interface/Buttons/GreyscaleRamp64",
				edgeFile = "Interface/Buttons/WHITE8X8",
				edgeSize = 1,
			});
	NewStatusBar:SetBackdropBorderColor(1,1,1,1);
	NewStatusBar:SetBackdropColor(1,1,1,0.2);
	NewStatusBar:GetStatusBarTexture():SetHorizTile(false)
	NewStatusBar:SetMinMaxValues(0, 100)
	NewStatusBar:SetValue(100)
	NewStatusBar:SetWidth(unrealtargetssettings['config']['width'])
	NewStatusBar:SetHeight(unrealtargetssettings['config']['height'])
	NewStatusBar:SetPoint("CENTER",posix, posiy)
	NewStatusBar:SetStatusBarColor(unrealtargetssettings['config']['color_r'],
		unrealtargetssettings['config']['color_g'],
		unrealtargetssettings['config']['color_b'])
	return NewStatusBar
end

SlashCmdList["cmdut"] = cmdut; 
SLASH_cmdut1 = "/utar";
SLASH_cmdut2 = "/UnrealTargets";
SLASH_cmdut3 = "/unrealtargets";
SLASH_cmdut4 = "/unrealtarget";
unitdb.slider ={}

UnrealTargets_options = {};
UnrealTargets_options.panel = CreateFrame("ScrollFrame", "UnrealTargetsPanel", UIParent );
UnrealTargets_options.panel.name = "UnrealTargets";
UnrealTargets_options.panel.okay = 
function (self)
	self.originalValue = MY_VARIABLE;
end
InterfaceOptions_AddCategory(UnrealTargets_options.panel)

local function showColorPicker(r,g,b,a,callback)
  ColorPickerFrame:SetColorRGB(r,g,b)
  ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), a
  ColorPickerFrame.previousValues = {r,g,b,a}
  ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = callback, callback, callback
  ColorPickerFrame:Hide() -- Need to run the OnShow handler.
  ColorPickerFrame:Show()
end
 
local function create_color_template(posix, posiy)
	--frame
	local f = CreateFrame("FRAME" ,"barcolor" , UnrealTargetsPanel)
	f:SetSize(15,15)
	f:SetPoint("TOPLEFT", posix, posiy)
	--texture
	f.tex = f:CreateTexture(nil,"ARTWORK",nil,-7)
	f.tex:SetAllPoints(f)
	f.tex:SetColorTexture(unrealtargetssettings['config']['color_r'],
		unrealtargetssettings['config']['color_g'],
		unrealtargetssettings['config']['color_b'],
		unrealtargetssettings['config']['color_a'])
	--recolor callback function
	f.recolorTexture = function(color)
		local r,g,b,a
		if color then
			r,g,b,a = unpack(color)
		else
			r,g,b = ColorPickerFrame:GetColorRGB()
			a = OpacitySliderFrame:GetValue()
			--print("new? "..r.." "..g.." "..b)
			unrealtargetssettings['config']['color_r'] = r
			unrealtargetssettings['config']['color_g'] = g
			unrealtargetssettings['config']['color_b'] = b
			unrealtargetssettings['config']['color_a'] = a
		end
		
		f.tex:SetColorTexture(r, g, b, a)
	end
	f:EnableMouse(true)
	f:SetScript("OnMouseDown", function(self,button,...)
		if button == "LeftButton" then
			local r,g,b,a = self.tex:GetVertexColor()
			showColorPicker(r,g,b,a,self.recolorTexture)
		end
	end)
	return f
end

function UnrealTargets:update_click(clickbutton, value)
	local myspellname = GetSpellInfo(value) or nil
	local spellid = 0
	if myspellname == nil then
		print('inputerror')
		return
	else
		_, _, _, _, _, _, spellid = GetSpellInfo(value)
		print(clickbutton..' is now '..myspellname..' spellid: '..spellid)
		unrealtargetssettings['config'][clickbutton] = value
	end
	local mymacrotext = "/cast "..myspellname
	if clickbutton == 'left' then
		targetframe['playertarget']:SetAttribute("macrotext1", mymacrotext);
		targetframe['pettarget']:SetAttribute("macrotext1", mymacrotext);
		for i = 1, 5, 1 do
			local raidid = "party"..i.."target"
			targetframe[raidid]:SetAttribute("macrotext1", mymacrotext);
		end
		for i = 1, 40, 1 do
			local raidid = "raid"..i.."target"
			targetframe[raidid]:SetAttribute("macrotext1", mymacrotext);
		end
	elseif clickbutton == 'right' then
		targetframe['playertarget']:SetAttribute("macrotext2", mymacrotext);
		targetframe['pettarget']:SetAttribute("macrotext2", mymacrotext);
		for i = 1, 5, 1 do
			local raidid = "party"..i.."target"
			targetframe[raidid]:SetAttribute("macrotext2", mymacrotext);
		end
		for i = 1, 40, 1 do
			local raidid = "raid"..i.."target"
			targetframe[raidid]:SetAttribute("macrotext2", mymacrotext);
		end
	else
	end
end

function UnrealTargets:Initialize()
	unrealtargetssettings['config']['height'] = unrealtargetssettings['config']['height'] or 30
	unrealtargetssettings['config']['width'] = unrealtargetssettings['config']['width'] or 175
	unrealtargetssettings['config']['rafter_distance'] = unrealtargetssettings['config']['rafter_distance'] or 5
	unrealtargetssettings['config']["posix"] = unrealtargetssettings['config']["posix"] or 1200
	unrealtargetssettings['config']["posiy"] = unrealtargetssettings['config']["posiy"] or 700
	unrealtargetssettings['config']["barnamecut"] = unrealtargetssettings['config']["barnamecut"] or 15
	unrealtargetssettings['config']["castbarnamecut"] = unrealtargetssettings['config']["castbarnamecut"] or 15
	unrealtargetssettings['config']['color_r'] = unrealtargetssettings['config']['color_r'] or 0.75
	unrealtargetssettings['config']['color_g'] = unrealtargetssettings['config']['color_g'] or 0.05
	unrealtargetssettings['config']['color_b'] = unrealtargetssettings['config']['color_b'] or 0.05
	unrealtargetssettings['config']['color_a'] = unrealtargetssettings['config']['color_a'] or 1
	unrealtargetssettings['config']['debufficonsize'] = unrealtargetssettings['config']['debufficonsize'] or 19
	unrealtargetssettings['config']['debufficonnumbersize'] = unrealtargetssettings['config']['debufficonnumbersize'] or 11
	unrealtargetssettings['config']['left'] = unrealtargetssettings['config']['left'] or 5116
	unrealtargetssettings['config']['right'] = unrealtargetssettings['config']['right'] or 34914
	
	do
		targetframe['playertarget'] = CreateFrame("Button", "MyParty1", UIParent, "SecureActionButtonTemplate")
		targetframe['playertarget']:SetAttribute("unit", "target")
		targetframe['playertarget']:SetAttribute("type1", "macro")

		local myspellname1 = GetSpellInfo(unrealtargetssettings['config']['left'])
		local mymacrotext1 = "/cast "..myspellname1
		targetframe['playertarget']:SetAttribute("macrotext1", mymacrotext1);
		targetframe['playertarget']:SetAttribute("type2", "macro")
		local myspellname2 = GetSpellInfo(unrealtargetssettings['config']['right'])
		local mymacrotext2 = "/cast "..myspellname2
		targetframe['playertarget']:SetAttribute("macrotext2", mymacrotext2);
		RegisterUnitWatch(targetframe['playertarget'])
		targetframe['playertarget']:RegisterForClicks( "LeftButtonUp", "MiddleButtonUp", "RightButtonUp", "Button4Up", "Button5Up",
												"Button6Up", "Button7Up", "Button8Up", "Button9Up", "Button10Up",
												"Button11Up", "Button12Up", "Button13Up", "Button14Up", "Button15Up");   
			
		targetframe['playertarget']:SetPoint("CENTER", 65, 100)
		targetframe['playertarget']:SetSize(50, 20)
		targetframe['playertarget']:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", tile = true, tileSize = 8 })
		targetframe['playertarget']:SetBackdropColor(0.6, 0.6, 0.6, 0.2)

		targetframe['pettarget'] = CreateFrame("Button", "MyParty1",UIParent, "SecureActionButtonTemplate")
		targetframe['pettarget']:SetAttribute("unit", "pettarget")
		targetframe['pettarget']:SetAttribute("type1", "macro")
		local myspellname3 = GetSpellInfo(unrealtargetssettings['config']['left'])
		local mymacrotext3 = "/cast [@pettarget] "..myspellname3
		local myspellname4 = GetSpellInfo(unrealtargetssettings['config']['right'])
		local mymacrotext4 = "/cast [@pettarget] "..myspellname4
		targetframe['pettarget']:SetAttribute("macrotext1", mymacrotext3);
		targetframe['pettarget']:SetAttribute("type2", "macro")
		targetframe['pettarget']:SetAttribute("macrotext2", mymacrotext4);
		RegisterUnitWatch(targetframe['pettarget'])
		targetframe['pettarget']:RegisterForClicks( "LeftButtonUp", "MiddleButtonUp", "RightButtonUp", "Button4Up", "Button5Up",
												"Button6Up", "Button7Up", "Button8Up", "Button9Up", "Button10Up",
												"Button11Up", "Button12Up", "Button13Up", "Button14Up", "Button15Up");   
			
		targetframe['pettarget']:SetPoint("CENTER", 65, 75)
		targetframe['pettarget']:SetSize(50, 20)
		targetframe['pettarget']:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", tile = true, tileSize = 8 })
		targetframe['pettarget']:SetBackdropColor(0.6, 0.6, 0.6, 0.2)



		do
			for i = 1, 5, 1 do
				local raidid = "party"..i.."target"
				targetframe[raidid] = CreateFrame("Button", "MyParty1",UIParent, "SecureActionButtonTemplate")
				targetframe[raidid]:SetAttribute("unit", raidid)
				targetframe[raidid]:SetAttribute("type1", "macro")
				local myspellname5 = GetSpellInfo(unrealtargetssettings['config']['left'])
				local mymacrotext5 = "/cast [@"..raidid.."] "..myspellname5
				local myspellname6 = GetSpellInfo(unrealtargetssettings['config']['right'])
				local mymacrotext6 = "/cast [@"..raidid.."] "..myspellname6
				targetframe[raidid]:SetAttribute("macrotext1", mymacrotext5);
				targetframe[raidid]:SetAttribute("type2", "macro")
				targetframe[raidid]:SetAttribute("macrotext2", mymacrotext6);
				RegisterUnitWatch(targetframe[raidid])
				targetframe[raidid]:RegisterForClicks( "LeftButtonUp", "MiddleButtonUp", "RightButtonUp", "Button4Up", "Button5Up",
														"Button6Up", "Button7Up", "Button8Up", "Button9Up", "Button10Up",
														"Button11Up", "Button12Up", "Button13Up", "Button14Up", "Button15Up");   
					
				targetframe[raidid]:SetPoint("CENTER", 125, 100-(i-1)*25)
				targetframe[raidid]:SetSize(50, 20)
				targetframe[raidid]:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", tile = true, tileSize = 8 })
				targetframe[raidid]:SetBackdropColor(0.6, 0.6, 0.6, 0.2)
			end
		end

		do
			for i = 1, 40, 1 do
				local raidid = "raid"..i.."target"
				targetframe[raidid] = CreateFrame("Button", "MyParty1",UIParent, "SecureActionButtonTemplate")
				targetframe[raidid]:SetAttribute("unit", raidid)
				targetframe[raidid]:SetAttribute("type1", "macro")
				local myspellname5 = GetSpellInfo(unrealtargetssettings['config']['left'])
				local mymacrotext5 = "/cast [@"..raidid.."] "..myspellname5
				local myspellname6 = GetSpellInfo(unrealtargetssettings['config']['right'])
				local mymacrotext6 = "/cast [@"..raidid.."] "..myspellname6
				targetframe[raidid]:SetAttribute("macrotext1", mymacrotext5);
				targetframe[raidid]:SetAttribute("type2", "macro")
				targetframe[raidid]:SetAttribute("macrotext2", mymacrotext6);
				RegisterUnitWatch(targetframe[raidid])
				targetframe[raidid]:RegisterForClicks( "LeftButtonUp", "MiddleButtonUp", "RightButtonUp", "Button4Up", "Button5Up",
														"Button6Up", "Button7Up", "Button8Up", "Button9Up", "Button10Up",
														"Button11Up", "Button12Up", "Button13Up", "Button14Up", "Button15Up");   
				local l = i-1
				local j = l%5
				local k = math.floor(l/5)
				targetframe[raidid]:SetPoint("CENTER", 125+k*60, 100-j*25)
				targetframe[raidid]:SetSize(50, 20)
				targetframe[raidid]:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", tile = true, tileSize = 8 })
				targetframe[raidid]:SetBackdropColor(0.6, 0.6, 0.6, 0.2)
			end
		end
	end
	
	UnrealTargets:raidgrid()
	local value2 = unrealtargetssettings['config']['height']
	local barcolor = create_color_template(15, -220)
	local name = "resetbutton"
	local template = "UIPanelButtonTemplate"
	local button = CreateFrame("Button", name, UnrealTargetsPanel, "UIPanelButtonTemplate") --frameType, frameName, frameParent, frameTemplate    
	button:SetSize(50,15)
	button:SetPoint("Topleft",10, -10)
	button.text = _G[name.."Text"]
	button.text:SetText("Reset")
	button:SetScript("OnClick", function(self, ...) 
		print("reset options")
		unrealtargetssettings['config']['height'] = 30
		unrealtargetssettings['config']['width'] = 175
		unrealtargetssettings['config']['rafter_distance'] = 5
		unrealtargetssettings['config']["posix"] = 1200
		unrealtargetssettings['config']["posiy"] = 700
		unrealtargetssettings['config']["barnamecut"] = 15
		unrealtargetssettings['config']["castbarnamecut"] = 15
		unrealtargetssettings['config']['color_r'] = 0.75
		unrealtargetssettings['config']['color_g'] = 0.05
		unrealtargetssettings['config']['color_b'] = 0.05
		unrealtargetssettings['config']['color_a'] = 1
		unrealtargetssettings['config']['debufficonsize'] = 1
		unrealtargetssettings['config']['debufficonnumbersize'] = 11
		unrealtargetssettings['clicks']['left'] = 5116
		unrealtargetssettings['clicks']['right'] = 34914
		unitdb.slider.height:SetValue(unrealtargetssettings['config']['height'])
		unitdb.slider.width:SetValue(unrealtargetssettings['config']['width'])
		unitdb.slider.rafter_distance:SetValue(unrealtargetssettings['config']['rafter_distance'])
		unitdb.slider.barnamecut:SetValue(unrealtargetssettings['config']["barnamecut"])
		unitdb.slider.castbarnamecut:SetValue(unrealtargetssettings['config']["castbarnamecut"])
		unitdb.allframes:SetPoint('BOTTOMLEFT', unrealtargetssettings['config']['posix'], unrealtargetssettings['config']['posiy'])
		barcolor.tex:SetTextColor(1, 0.1, 0.1, 1)
	end)
	
	unitdb.header1 = UnrealTargets_options.panel:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.header1:SetPoint("Topleft",200, -40)
	unitdb.header1:SetText("Bar Options")
	unitdb.header1:SetFont("Fonts\\FRIZQT__.ttf",18,"OUTLINE")
	unitdb.header1:SetTextColor(red.r, red.g, red.b)
	unitdb.header2 = UnrealTargets_options.panel:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.header2:SetPoint("Topleft",35, -222)
	unitdb.header2:SetText("Barcolor")
	unitdb.header2:SetFont("Fonts\\FRIZQT__.ttf",12,"OUTLINE")

	
	-- barheight
	unitdb.slider.height = UnrealTargets:option_slider('height', UnrealTargetsPanel, "TOPLEFT", 10, -80, 4, 50, 'height', unrealtargetssettings['config']['height'])
	unitdb.slider.height:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']['height'] = event
		unitdb.slider.height.editBox:SetText(event)
	end)
	unitdb.slider.height.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.height.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']['height']
		if value > 50 then
			value = 50
		elseif value < 4 then
			value = 4
		end
		unitdb.slider.height.editBox:SetText(value)
		unrealtargetssettings['config']['height'] = value
		unitdb.slider.height:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.height.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.height.editBox:SetText(unrealtargetssettings['config']['height'])
		self:ClearFocus()
	end)
	
	-- barwidth
	unitdb.slider.width = UnrealTargets:option_slider('width', UnrealTargetsPanel, "TOPLEFT", 185, -80, 25, 500, 'width', unrealtargetssettings['config']['width'])
	unitdb.slider.width:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']['width'] = event
		unitdb.slider.width.editBox:SetText(event)
	end)
	unitdb.slider.width.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.width.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']['width']
		if value > 500 then
			value = 500
		elseif value < 25 then
			value = 25
		end
		unitdb.slider.width.editBox:SetText(value)
		unrealtargetssettings['config']['width'] = value
		unitdb.slider.width:SetValue(value)
		unitdb.allframes:SetWidth(value)
		self:ClearFocus()		
	end)
	unitdb.slider.width.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.width.editBox:SetText(unrealtargetssettings['config']['width'])
		self:ClearFocus()
	end)

	-- bar rafter distance
	unitdb.slider.rafter_distance = UnrealTargets:option_slider('rafter_distance', UnrealTargetsPanel, "TOPLEFT", 360, -80, 0, 25, "Bar-Distance", unrealtargetssettings['config']['rafter_distance'])
	unitdb.slider.rafter_distance:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']['rafter_distance'] = event
		unitdb.slider.rafter_distance.editBox:SetText(event)
	end)
	unitdb.slider.rafter_distance.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.rafter_distance.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']['rafter_distance']
		if value > 25 then
			value = 25
		elseif value < 0 then
			value = 0
		end
		unitdb.slider.rafter_distance.editBox:SetText(value)
		unrealtargetssettings['config']['rafter_distance'] = value
		unitdb.slider.rafter_distance:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.rafter_distance.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.rafter_distance.editBox:SetText(unrealtargetssettings['config']['rafter_distance'])
		self:ClearFocus()
	end)

	-- bar posi x
	-- unitdb.slider.posix = UnrealTargets:option_slider("posix", UnrealTargetsPanel, "TOPLEFT", 10, -140, -1000, 1000, "X-position", unrealtargetssettings['config']["posix"])
	-- unitdb.slider.posix:SetScript("OnValueChanged", function(self,event,arg1) 
		-- event = round(event)
		-- self:SetValue(event)
		-- unrealtargetssettings['config']["posix"] = event
		-- unitdb.slider.posix.editBox:SetText(event)
	-- end)
	-- unitdb.slider.posix.editBox:SetScript( "OnEnterPressed", function(self) 
		-- local value = unitdb.slider.posix.editBox:GetText()
		-- value = tonumber(value) or unrealtargetssettings['config']["posix"]
		-- if value > 1000 then
			-- value = 1000
		-- elseif value < -1000 then
			-- value = -1000
		-- end
		-- unitdb.slider.posix.editBox:SetText(value)
		-- unrealtargetssettings['config']["posix"] = value
		-- unitdb.slider.posix:SetValue(value)
		-- self:ClearFocus()		
	-- end)
	-- unitdb.slider.posix.editBox:SetScript( "OnEscapePressed", function(self)
		-- unitdb.slider.posix.editBox:SetText(unrealtargetssettings['config']["posix"])
		-- self:ClearFocus()
	-- end)

	-- -- bar posi y
	-- unitdb.slider.posiy = UnrealTargets:option_slider("posiy", UnrealTargetsPanel, "TOPLEFT", 185, -140, -1000, 1000, "Y-position", unrealtargetssettings['config']["posiy"])
	-- unitdb.slider.posiy:SetScript("OnValueChanged", function(self,event,arg1) 
		-- event = round(event)
		-- self:SetValue(event)
		-- unrealtargetssettings['config']["posiy"] = event
		-- unitdb.slider.posiy.editBox:SetText(event)
	-- end)
	-- unitdb.slider.posiy.editBox:SetScript( "OnEnterPressed", function(self) 
		-- local value = unitdb.slider.posiy.editBox:GetText()
		-- value = tonumber(value) or unrealtargetssettings['config']["posiy"]
		-- if value > 1000 then
			-- value = 1000
		-- elseif value < -1000 then
			-- value = -1000
		-- end
		-- unitdb.slider.posiy.editBox:SetText(value)
		-- unrealtargetssettings['config']["posiy"] = value
		-- unitdb.slider.posiy:SetValue(value)
		-- self:ClearFocus()		
	-- end)
	-- unitdb.slider.posiy.editBox:SetScript( "OnEscapePressed", function(self)
		-- unitdb.slider.posiy.editBox:SetText(unrealtargetssettings['config']["posiy"])
		-- self:ClearFocus()
	-- end)
	
	-- cut bar name 
	unitdb.slider.barnamecut = UnrealTargets:option_slider("cut_barname", UnrealTargetsPanel, "TOPLEFT", 10, -140, 3, 100, "Barnamecut", unrealtargetssettings['config']["barnamecut"])
	unitdb.slider.barnamecut:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']["barnamecut"] = event
		unitdb.slider.barnamecut.editBox:SetText(event)
	end)
	unitdb.slider.barnamecut.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.barnamecut.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']["barnamecut"]
		if value > 100 then
			value = 100
		elseif value < 3 then
			value = 3
		end
		unitdb.slider.barnamecut.editBox:SetText(value)
		unrealtargetssettings['config']["barnamecut"] = value
		unitdb.slider.barnamecut:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.barnamecut.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.barnamecut.editBox:SetText(unrealtargetssettings['config']["barnamecut"])
		self:ClearFocus()
	end)
	
	-- cut castbar name 
	unitdb.slider.castbarnamecut = UnrealTargets:option_slider("castbarnamecut", UnrealTargetsPanel, "TOPLEFT", 185, -140, 3, 100, "Castbarnamecut", unrealtargetssettings['config']["castbarnamecut"])
	unitdb.slider.castbarnamecut:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']["castbarnamecut"] = event
		unitdb.slider.castbarnamecut.editBox:SetText(event)
	end)
	unitdb.slider.castbarnamecut.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.castbarnamecut.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']["castbarnamecut"]
		if value > 100 then
			value = 100
		elseif value < 3 then
			value = 3
		end
		unitdb.slider.castbarnamecut.editBox:SetText(value)
		unrealtargetssettings['config']["castbarnamecut"] = value
		unitdb.slider.castbarnamecut:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.castbarnamecut.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.castbarnamecut.editBox:SetText(unrealtargetssettings['config']["castbarnamecut"])
		self:ClearFocus()
	end)
	unitdb.slider.castbarnamecut:Hide()
	unitdb.slider.castbarnamecut:Show()
	
	-- debufficonsize
	unitdb.slider.debufficonsize = UnrealTargets:option_slider('iconsize', UnrealTargetsPanel, "TOPLEFT", 10, -260, 3, 50, 'Iconsize', unrealtargetssettings['config']['debufficonsize'], 1e-1)
	unitdb.slider.debufficonsize:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']['debufficonsize'] = event
		unitdb.slider.debufficonsize.editBox:SetText(event)
	end)
	unitdb.slider.debufficonsize.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.debufficonsize.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']['debufficonsize']
		if value > 50 then
			value = 50
		elseif value < 3 then
			value = 3
		end
		unitdb.slider.debufficonsize.editBox:SetText(value)
		unrealtargetssettings['config']['debufficonsize'] = value
		unitdb.slider.debufficonsize:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.debufficonsize.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.debufficonsize.editBox:SetText(unrealtargetssettings['config']['debufficonsize'])
		self:ClearFocus()
	end)
	
	unitdb.header3 = UnrealTargets_options.panel:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.header3:SetPoint("Topleft",200, -320)
	unitdb.header3:SetText("Click Options")
	unitdb.header3:SetFont("Fonts\\FRIZQT__.ttf",18,"OUTLINE")
	unitdb.header3:SetTextColor(red.r, red.g, red.b)
	unitdb.header4 = UnrealTargets_options.panel:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.header4:SetPoint("Topleft",70, -340)
	unitdb.header4:SetText("Leftclick")
	unitdb.header4:SetFont("Fonts\\FRIZQT__.ttf",12,"OUTLINE")
	unitdb.header5 = UnrealTargets_options.panel:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.header5:SetPoint("Topleft",370, -340)
	unitdb.header5:SetText("Rightclick")
	unitdb.header5:SetFont("Fonts\\FRIZQT__.ttf",12,"OUTLINE")
	
	-- leftclick 
	unitdb.slider.leftclick = UnrealTargets:option_editbox('left', UnrealTargetsPanel, "TOPLEFT", 10, -360, 200, 14, 'LEFT', unrealtargetssettings['config']['left'])
	unitdb.slider.leftclick:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.leftclick:GetText()
		--value = tonumber(value) or unrealtargetssettings['config']['left']
		unitdb.slider.leftclick:SetText(value)
		--unitdb.slider.leftclick:SetValue(value)
		UnrealTargets:update_click('left', value)
		self:ClearFocus()		
	end)
	unitdb.slider.leftclick:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.leftclick:SetText(unrealtargetssettings['config']['left'])
		self:ClearFocus()
	end)
	
	--rightclick
	unitdb.slider.rightclick = UnrealTargets:option_editbox('right', UnrealTargetsPanel, "TOPLEFT", 300, -360, 200, 14, 'RIGHT', unrealtargetssettings['config']['right'])
	unitdb.slider.rightclick:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.rightclick:GetText()
		--value = tonumber(value) or unrealtargetssettings['config']['right']
		unitdb.slider.rightclick:SetText(value)
		--unitdb.slider.rightclick:SetValue(value)
		UnrealTargets:update_click('right', value)
		self:ClearFocus()		
	end)
	unitdb.slider.rightclick:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.rightclick:SetText(unrealtargetssettings['config']['right'])
		self:ClearFocus()
	end)
	
	
	unitdb.allframes = CreateFrame("StatusBar", 'allframes', UIParent)
	unitdb.allframes:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	unitdb.allframes:SetWidth(unrealtargetssettings['config']['width'])
	unitdb.allframes:SetHeight(10)
	unitdb.allframes:Hide()
	unitdb.allframes:SetPoint('BOTTOMLEFT', unrealtargetssettings['config']['posix'], unrealtargetssettings['config']['posiy'])
	unitdb.allframes:SetStatusBarColor(1,1,1,0)
	unitdb.allframes:SetMovable(false)
	unitdb.allframes:EnableMouse(false)
	unitdb.allframes:SetScript('OnDragStart', unitdb.allframes.StartMoving)
	unitdb.allframes:SetScript('OnDragStop',  function(self, ...)
		self:StopMovingOrSizing()
		unrealtargetssettings['config']['posix'] = self:GetLeft()
		unrealtargetssettings['config']['posiy'] = self:GetBottom()
	end)
	
	local checkname = 'Cheackdragable'
	local checkButton = CreateFrame('CheckButton', checkname, UnrealTargetsPanel, 'UICheckButtonTemplate') --frameType, frameName, frameParent, frameTemplate    
	checkButton:SetPoint("CENTER",0,0)
	checkButton.text = _G[checkname.."Text"]
	checkButton.text:SetText("Lock Enemyframe")
	checkButton:SetPoint('Topleft', 360, -140)
	checkButton:SetChecked(true)
	checkButton:SetScript("OnClick", function(self,event,arg1) 
		local isChecked = checkButton:GetChecked()
		if isChecked then
			unitdb.allframes:EnableMouse(false)
			unitdb.allframes:SetMovable(false)
			unitdb.allframes:UnregisterAllEvents()
		else
			unitdb.allframes:EnableMouse(true)
			unitdb.allframes:SetMovable(true)
			unitdb.allframes:RegisterForDrag('LeftButton')
		end
	end)

	-- myunits.bar = UnrealTargets:set_hp_frame(0, 0, 'mytestbar', UiParent)
	-- local testheightbar = 33
	-- local testwidthbar = 200
	-- myunits.bar:SetWidth(testwidthbar)
	-- myunits.bar:SetHeight(testheightbar)
	-- myunits.fontname = myunits.bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	-- myunits.fontname:SetPoint("TOPLEFT", 0, 0)
	-- local targetname = UnrealTargets:cut_name("testabcdefghijklmnopqrstuvwxyz")
	-- myunits.fontname:SetText(targetname)
	-- myunits.fontname:SetFont("Fonts\\FRIZQT__.ttf",testheightbar*20/33,"OUTLINE")
	-- myunits.fonthppercent = myunits.bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	-- myunits.fonthppercent:SetPoint("TOPRIGHT", 0, 0)
	-- myunits.fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",testheightbar*20/33,"OUTLINE")	
	-- myunits.bar:SetMovable(true)
	-- myunits.bar:EnableMouse(true)
	-- myunits.bar:RegisterForDrag("LeftButton")
	-- myunits.bar:SetScript("OnDragStart", myunits.bar.StartMoving)
	-- myunits.bar:SetScript("OnDragStop", myunits.bar.StopMovingOrSizing)
	-- myunits.castbar = UnrealTargets:set_hp_frame(0, -testheightbar/3, 'mytestbarcastline', myunits.bar)
	-- myunits.castbar:SetWidth(testwidthbar)
	-- myunits.castbar:SetHeight(testheightbar/3)
	-- myunits.castbar:SetStatusBarColor(1,0,1)
	-- myunits.castbar:Hide()
	-- local icon = select(3,GetSpellInfo(740))
	-- myunits.icon = CreateFrame("StatusBar", 'mytestbaricon', myunits.bar)
	-- myunits.icon:SetStatusBarTexture(icon)
	-- myunits.icon:SetWidth(testheightbar)
	-- myunits.icon:SetHeight(testheightbar)
	-- myunits.icon:SetPoint("Topleft", -testheightbar, 0)
	-- myunits.icon:Hide()
	
	-- local icon = select(3,GetSpellInfo(740))
	-- local browsertest = CreateFrame('Browser', 'browsertest1', uiparent)
	-- browsertest:SetWidth(50)
	-- browsertest:SetHeight(50)
	-- browsertest:SetPoint("CENTER", 0, 0)
	-- browsertest.texture = browsertest:CreateTexture('color', 'OVERLAY')
	-- browsertest.texture:SetTexture(1,0,0,0.5)
	-- browsertest.texture:SetSize(50, 50)
	-- browsertest.texture:SetPoint('Topright', 0, 0)
	-- browsertest:HasConnection() 
	-- browsertest:OpenExternalLink("http://www.google.de") 
end

function UnrealTargets:frame_posi_update()
	unitdb.allframes:StopMovingOrSizing()
end

function UnrealTargets:frequently_frame_update(...)
	local guid = UnitGUID(...)
	local mytype, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
	local max_health = UnitHealthMax(...)
	local currenthealth = UnitHealth(...)
	if max_health ~= 0 and currenthealth ~= 0 then
		if npc_id then
			unitdb.unitsmaxhp[npc_id] = {}
			unitdb.unitsmaxhp[npc_id].maxhp = max_health
			for i, unitguid in ipairs(unitdb.allunitguids) do
				if unitguid == guid then
					unitdb.units[guid].maxhp = max_health
					unitdb.units[guid].hp = currenthealth
					local health = unitdb.units[guid].hp / unitdb.units[guid].maxhp * 100
					health = string_format("%.0f", health)
					unitdb.units[guid].bar:SetValue(health)
					health = health.."%"
					unitdb.units[guid].fonthppercent:SetText(health)
				end
			end
		end
	end
	for k, unitguid in ipairs(unitdb.allunitguids) do
		if unitguid == destGUID then
			--unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
			local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
			health = string_format("%.0f", health)
			unitdb.units[destGUID].bar:SetValue(health)
			health = health.."%"
			unitdb.units[destGUID].fonthppercent:SetText(health)
		end
	end
end

function UnrealTargets:sortdebuffs(destGUID)
	local debuffnumbers = 0
	for i, spellnameplusGUID in ipairs(unitdb.playerdebuffs) do
		local spname, dGUID = strsplit('|', spellnameplusGUID)
		if dGUID == destGUID then
			if unitdb.units[dGUID] then
				if unitdb.units[dGUID].debuff[spname] and unitdb.units[dGUID].debuff[spname]:GetPoint() then
					unitdb.units[dGUID].debuff[spname]:SetPoint("Topleft", 3+21*debuffnumbers, -3)
					debuffnumbers = debuffnumbers + 1	
				end
			end
		end
	end
end

function UnrealTargets:insert_debuff_in_db(spellId, name, icon, duration)
	local spelliddb = spellId..'db'
	if not unitdb.debuffinfo[spelliddb] then
		unitdb.debuffinfo[spelliddb] = {}
	end
	unitdb.debuffinfo[spelliddb].spellId = spellId
	unitdb.debuffinfo[spelliddb].name = name
	unitdb.debuffinfo[spelliddb].icon = icon
	unitdb.debuffinfo[spelliddb].duration = duration
end



function UnrealTargets:frame_update(_, event,hide,srcGUID,srcName,srcF1,srcF2,destGUID,destName, ...)
	local localtime = GetTime()
	local mytype, _, _, _, _, npc_id, _ = strsplit("-",destGUID)
	local sourcetype, _, _, _, _, srcnpc_id, _  = strsplit("-",srcGUID)
	local unit = destName
	local isindb = false
	local ignornpcid = false
	-- if unitdb.zone == false then
		-- print('isopenworld')
	-- end
	-- if event == 'SPELL_MISSED' then
		-- print('missed')
	-- end
	if event == 'SPELL_AURA_APPLIED_DOSE' then
		
		local _, _, spellId, spellname, _, auratype, amount = ...
	elseif event == "SPELL_AURA_APPLIED" then
		local _, _, spellId, spellname, _, auratype = ...
		if spellId == 182387 then
			return
		end
		if srcGUID == UnitGUID('player') and self:ignor_buff(spellId) == false then
			local spelliddb = spellId..'db'
			if UnitGUID('target') == destGUID then
				local name, _, icon, _, _, duration, expirationTime, unitCaster = UnitDebuff('target', spellname)
				if not unitdb.debuffinfo[spelliddb] then
					self:insert_debuff_in_db(spellId, name, icon, duration)
				end
				unitCaster = unitCaster or 0
				name = name or 'none'
				local remaining_time = expirationTime - localtime
				duration = duration or 0
				if remaining_time >= 0 and remaining_time < 100 then
					if unitdb.units[destGUID] then
						if not unitdb.units[destGUID].debuff[spellname] then
							unitdb.units[destGUID].debuff[spellname] = {}
						end
						unitdb.units[destGUID].debuff[spellname] = CreateFrame("Button", 'debuff'..destGUID..name, unitdb.units[destGUID].bar)
						unitdb.units[destGUID].debuff[spellname].name = name
						unitdb.units[destGUID].debuff[spellname].icon = icon
						unitdb.units[destGUID].debuff[spellname].duration = duration
						unitdb.units[destGUID].debuff[spellname].expirationTime = expirationTime
						unitdb.units[destGUID].debuff[spellname]:SetNormalTexture(icon)
						unitdb.units[destGUID].debuff[spellname]:SetWidth(19)
						unitdb.units[destGUID].debuff[spellname]:SetHeight(19)
						unitdb.units[destGUID].debuff[spellname]:SetPoint("Topleft", 3+21*unitdb.units[destGUID].debuffnumbers, -3)
						unitdb.units[destGUID].debuff[spellname].fontduration = unitdb.units[destGUID].debuff[spellname]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
						unitdb.units[destGUID].debuff[spellname].fontduration:SetPoint("Center", 0, 0)
						unitdb.units[destGUID].debuff[spellname].fontduration:SetText(duration)
						unitdb.units[destGUID].debuff[spellname].fontduration:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
						unitdb.units[destGUID].debuffnumbers = unitdb.units[destGUID].debuffnumbers + 1
						table_insert(unitdb.playerdebuffs, spellname..'|'..destGUID)
						
						self:sortdebuffs(dGUID)
					end
				end
			else
				if unitdb.units[destGUID] then
					if unitdb.debuffinfo[spelliddb] then
						if not unitdb.units[destGUID].debuff[spellname] then
							unitdb.units[destGUID].debuff[spellname] = {}
						end
						unitdb.units[destGUID].debuff[spellname] = CreateFrame("Button", 'debuff'..destGUID..unitdb.debuffinfo[spelliddb].name, unitdb.units[destGUID].bar)
						unitdb.units[destGUID].debuff[spellname].name = unitdb.debuffinfo[spelliddb].name
						unitdb.units[destGUID].debuff[spellname].icon = unitdb.debuffinfo[spelliddb].icon
						unitdb.units[destGUID].debuff[spellname].duration = unitdb.debuffinfo[spelliddb].duration
						unitdb.units[destGUID].debuff[spellname].expirationTime = unitdb.debuffinfo[spelliddb].duration + GetTime()
						unitdb.units[destGUID].debuff[spellname]:SetNormalTexture(unitdb.debuffinfo[spelliddb].icon)
						unitdb.units[destGUID].debuff[spellname]:SetWidth(19)
						unitdb.units[destGUID].debuff[spellname]:SetHeight(19)
						unitdb.units[destGUID].debuff[spellname]:SetPoint("Topleft", 3+21*unitdb.units[destGUID].debuffnumbers, -3)
						unitdb.units[destGUID].debuff[spellname].fontduration = unitdb.units[destGUID].debuff[spellname]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
						unitdb.units[destGUID].debuff[spellname].fontduration:SetPoint("Center", 0, 0)
						unitdb.units[destGUID].debuff[spellname].fontduration:SetText(unitdb.debuffinfo[spelliddb].duration)
						unitdb.units[destGUID].debuff[spellname].fontduration:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
						unitdb.units[destGUID].debuffnumbers = unitdb.units[destGUID].debuffnumbers + 1
						table_insert(unitdb.playerdebuffs, spellname..'|'..destGUID)
						
						self:sortdebuffs(dGUID)
					end
				end
			end
		end
	elseif event == 'SPELL_AURA_REMOVED' then
		local _, _, spellId, spellname, _, auratype, amount = ...
		if srcGUID == UnitGUID('player') then
			
		end
		for i, spellnameplusGUID in ipairs(unitdb.playerdebuffs) do
			local spname, dGUID = strsplit('|', spellnameplusGUID)
			if destGUID == dGUID and spname == spellname then
				if unitdb.units[dGUID] then
					if unitdb.units[dGUID].debuff[spname] then
						--print('Hide '..spname)
						unitdb.units[dGUID].debuff[spname]:Hide()
						unitdb.units[dGUID].debuff[spname] = {}
						table_remove(unitdb.playerdebuffs, i)
						unitdb.units[destGUID].debuffnumbers = unitdb.units[destGUID].debuffnumbers - 1
						self:sortdebuffs(dGUID)
					end
				end
			end
		end
	elseif event == 'SPELL_AURA_REFRESH' or event == 'SPELL_AURA_APPLIED_DOSE' then
		local _, _, spellId, spellname, _, auratype = ...
		if srcGUID == UnitGUID('player') then
			local spelliddb = spellId..'db'
			if UnitGUID('target') == destGUID then
				local name, _, icon, _, _, duration, expirationTime, unitCaster, _, _, spellId = UnitDebuff('target', spellname )
				if not unitdb.debuffinfo[spelliddb] then
					self:insert_debuff_in_db(spellId, name, icon, duration)
				end
				unitCaster = unitCaster or 0
				name = name or 'noone'
				duration = duration or 0
				local remaining_time = expirationTime - localtime
				if remaining_time >= 0 and remaining_time < 100 then
					expirationTime = expirationTime or GetTime()
					if unitdb.units[destGUID] then
						if not unitdb.units[destGUID].debuff[spellname] then
							unitdb.units[destGUID].debuff[spellname] = {}
							unitdb.units[destGUID].debuff[spellname] = CreateFrame("Button", 'debuff'..destGUID..name, unitdb.units[destGUID].bar)
							unitdb.units[destGUID].debuff[spellname].name = name
							unitdb.units[destGUID].debuff[spellname].icon = icon
							unitdb.units[destGUID].debuff[spellname].duration = duration
							unitdb.units[destGUID].debuff[spellname].expirationTime = expirationTime
							unitdb.units[destGUID].debuff[spellname]:SetNormalTexture(icon)
							unitdb.units[destGUID].debuff[spellname]:SetWidth(19)
							unitdb.units[destGUID].debuff[spellname]:SetHeight(19)
							unitdb.units[destGUID].debuff[spellname]:SetPoint("Topleft", 3+21*unitdb.units[destGUID].debuffnumbers, -3)
							unitdb.units[destGUID].debuff[spellname].fontduration = unitdb.units[destGUID].debuff[spellname]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
							unitdb.units[destGUID].debuff[spellname].fontduration:SetPoint("Center", 0, 0)
							unitdb.units[destGUID].debuff[spellname].fontduration:SetText(duration)
							unitdb.units[destGUID].debuff[spellname].fontduration:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
							unitdb.units[destGUID].debuffnumbers = unitdb.units[destGUID].debuffnumbers + 1
							table_insert(unitdb.playerdebuffs, spellname..'|'..destGUID)
							
						else
							unitdb.units[destGUID].debuff[spellname].fontduration:SetText(duration)
							unitdb.units[destGUID].debuff[spellname].expirationTime = expirationTime
							
						end
						self:sortdebuffs(dGUID)
					end
				end
			else
				if unitdb.units[destGUID] then
					if not unitdb.units[destGUID].debuff[spellname] then
						if unitdb.debuffinfo[spelliddb] then
							if not unitdb.units[destGUID].debuff[spellname] then
								unitdb.units[destGUID].debuff[spellname] = {}
							end
							unitdb.units[destGUID].debuff[spellname] = CreateFrame("Button", 'debuff'..destGUID..unitdb.debuffinfo[spelliddb].name, unitdb.units[destGUID].bar)
							unitdb.units[destGUID].debuff[spellname].name = unitdb.debuffinfo[spelliddb].name
							unitdb.units[destGUID].debuff[spellname].icon = unitdb.debuffinfo[spelliddb].icon
							unitdb.units[destGUID].debuff[spellname].duration = unitdb.debuffinfo[spelliddb].duration
							unitdb.units[destGUID].debuff[spellname].expirationTime = unitdb.debuffinfo[spelliddb].duration + GetTime()
							unitdb.units[destGUID].debuff[spellname]:SetNormalTexture(unitdb.debuffinfo[spelliddb].icon)
							unitdb.units[destGUID].debuff[spellname]:SetWidth(19)
							unitdb.units[destGUID].debuff[spellname]:SetHeight(19)
							unitdb.units[destGUID].debuff[spellname]:SetPoint("Topleft", 3+21*unitdb.units[destGUID].debuffnumbers, -3)
							unitdb.units[destGUID].debuff[spellname].fontduration = unitdb.units[destGUID].debuff[spellname]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
							unitdb.units[destGUID].debuff[spellname].fontduration:SetPoint("Center", 0, 0)
							unitdb.units[destGUID].debuff[spellname].fontduration:SetText(unitdb.debuffinfo[spelliddb].duration)
							unitdb.units[destGUID].debuff[spellname].fontduration:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
							unitdb.units[destGUID].debuffnumbers = unitdb.units[destGUID].debuffnumbers + 1
							table_insert(unitdb.playerdebuffs, spellname..'|'..destGUID)
							
							self:sortdebuffs(dGUID)
						end
					else
						if unitdb.debuffinfo[spelliddb] then
							unitdb.units[destGUID].debuff[spellname].fontduration:SetText(unitdb.debuffinfo[spelliddb].duration)
							unitdb.units[destGUID].debuff[spellname].expirationTime = unitdb.debuffinfo[spelliddb].duration + GetTime()
							self:sortdebuffs(dGUID)
						end
					end
				end
			end		
		end
	end				
	for i, unitguid in ipairs(unitdb.allunitguids) do
		if unitguid == destGUID then
			if unit ~= "player" then
				--print(hide)
				if event == "UNIT_DIED" then
					table_remove(unitdb.allunitguids, i)
					unitdb.units[unitguid].bar:Hide()
					unitdb.units[unitguid].castbar:Hide()
					self:update_frame_posis()
				elseif event == "SWING_DAMAGE" then
					local _,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "SPELL_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "RANGE_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "SPELL_PERIODIC_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif  event == "SPELL_INTERRUPT" then
					local _, _, spellID, spellname, spellSchool = ...
					local castname, _, icon = GetSpellInfo(spellID)
					unitdb.units[destGUID].icon:SetTexture(GetSpellTexture(spellID))
					unitdb.units[destGUID].castinterrupt = true
					unitdb.units[destGUID].castTimeend = GetTime()+3
					local green = GREEN_FONT_COLOR 
					unitdb.units[destGUID].castbar:SetStatusBarColor(green.r, green.g, green.b)
					unitdb.units[destGUID].castbar_fontname:SetText('Interrupt')
				elseif event == "SPELL_AURA_APPLIED" then
					local _, _, spellId, spellname, _, auratype = ...
					
					for i, dbspellID in ipairs(db.silencespells) do
						if spellId == dbspellID then
							local icon = select(3,GetSpellInfo(spellId))
							unitdb.units[destGUID].icon:SetTexture(GetSpellTexture(spellId))
							unitdb.units[destGUID].castinterrupt = true
							unitdb.units[destGUID].castTimeend = GetTime()+3
							local green = GREEN_FONT_COLOR 
							unitdb.units[destGUID].castbar:SetStatusBarColor(green.r, green.g, green.b)
							unitdb.units[destGUID].castbar_fontname:SetText('Silence Interrupt')
							return
						end
					end
					for i, dbspellID in ipairs(db.stunspells) do
						if spellId == dbspellID then
							local icon = select(3,GetSpellInfo(spellId))
							unitdb.units[destGUID].icon:SetTexture(GetSpellTexture(spellId))
							unitdb.units[destGUID].castinterrupt = true
							unitdb.units[destGUID].castTimeend = GetTime()+3
							local green = GREEN_FONT_COLOR 
							unitdb.units[destGUID].castbar:SetStatusBarColor(green.r, green.g, green.b)
							unitdb.units[destGUID].castbar_fontname:SetText('Stun Interrupt')
							return
						end
					end
					for i, dbspellID in ipairs(db.incapacitatesspells) do
						if spellId == dbspellID then
							local icon = select(3,GetSpellInfo(spellId))
							unitdb.units[destGUID].icon:SetTexture(GetSpellTexture(spellId))
							unitdb.units[destGUID].castinterrupt = true
							unitdb.units[destGUID].castTimeend = GetTime()+3
							local green = GREEN_FONT_COLOR 
							unitdb.units[destGUID].castbar:SetStatusBarColor(green.r, green.g, green.b)
							unitdb.units[destGUID].castbar_fontname:SetText('Incapacitates Interrupt')
							--print(spellId)
							return
						end
					end
					for i, dbspellID in ipairs(db.disorientsspells) do
						if spellId == dbspellID then
							local icon = select(3,GetSpellInfo(spellId))
							unitdb.units[destGUID].icon:SetTexture(GetSpellTexture(spellId))
							unitdb.units[destGUID].castinterrupt = true
							unitdb.units[destGUID].castTimeend = GetTime()+3
							local green = GREEN_FONT_COLOR 
							unitdb.units[destGUID].castbar:SetStatusBarColor(green.r, green.g, green.b)
							unitdb.units[destGUID].castbar_fontname:SetText('Disorients Interrupt')
							--print(spellId)
							return
						end
					end
				end
			end
			isindb = true
		elseif unitguid == srcGUID then
			 if event == 'SPELL_CAST_START' then
				local _, _, spellID, spellname, spellSchool = ...
				_, _, _, unitdb.units[srcGUID].castTime = GetSpellInfo(spellID)
				local castname, _, icon = GetSpellInfo(spellID)
				castname = self:cut_name(castname, 13)
				unitdb.units[srcGUID].castbar_fontname:SetText(castname)
				unitdb.units[srcGUID].icon:Show()
				unitdb.units[srcGUID].icon:SetTexture(GetSpellTexture(spellID))
				unitdb.units[srcGUID].castbar:Show()
				unitdb.units[srcGUID].castTime =  unitdb.units[srcGUID].castTime/1000
				unitdb.units[srcGUID].castTimeend = unitdb.units[srcGUID].castTime + GetTime()
				local castcolor = {}
				castcolor.r, castcolor.g, castcolor.b = self:get_spellschool_color_code(spellSchool)
				unitdb.units[srcGUID].castbar:SetStatusBarColor(castcolor.r, castcolor.g, castcolor.b)
				unitdb.units[srcGUID].castinterrupt = false
				--print('cast start '..spellname..' '..unitdb.units[srcGUID].castTime)
			-- elseif event == 'SPELL_CAST_FAILED' then
				-- local _, _, spellID, spellname, spellSchool = ...
				-- print('Spell cancel from '..srcName..': spell: '..spellname)
			end
		end
	end
	if not isindb then
		if event == 'RANGE_DAMAGE' 
			or event == 'SPELL_DAMAGE' 
			or event == 'SPELL_PERIODIC_DAMAGE' 
			or event == 'SWING_DAMAGE' then
			--print('true')
			for i, groupguid in ipairs(unitdb.groupmembers) do
				self:insert_target('Creature', 'Vehicle', mytype, sourcetype, npc_id, destName, destGUID, srcGUID, groupguid, srcName, ...)
			end
			for i, petguid in ipairs(unitdb.grouppets) do
				self:insert_target('Creature', 'Vehicle', mytype, sourcetype, npc_id, destName, destGUID, srcGUID, petguid, srcName, ...)
			end
		end
	end
end

function UnrealTargets:insert_target(thetarget1, thetarget2, thesource1, thesource2, npc_id, destName, destGUID, srcGUID, guid, srcName, ...)
	if thesource1 == thetarget1 and srcGUID == guid or thesource1 == thetarget2 and srcGUID == guid then
		--print('true2')
		if unitdb.isinfight == true then
			ignornpcid = self:ignor_npc(npc_id)
			if event == 'SPELL_HEAL' 
				or event == 'SPELL_PERIODIC_HEAL' 
				or event == 'SPELL_AURA_APPLIED' 
				or event == 'SPELL_AURA_REMOVED'
				or event == 'SPELL_AURA_REFRESH'then
				ignornpcid = true
			end
			if ignornpcid == false then
				UnrealTargets:create_frame(npc_id, destName, destGUID)
				if event == "SWING_DAMAGE" then
					local _,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "SPELL_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "RANGE_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "SPELL_PERIODIC_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()--print('add '..event..' '..destName)
				end
			end
		end
	elseif thesource1 == guid and srcGUID == thetarget1 or thesource1 == guid and srcGUID == thetarget2 then
		--print('true3')
		if unitdb.isinfight == true then
			ignornpcid = self:ignor_npc(srcnpc_id)
			for _, unitguid in ipairs(unitdb.allunitguids) do
				if unitguid == srcGUID then
					ignornpcid = true
				end
			end
			if event == 'SPELL_HEAL' 
				or event == 'SPELL_PERIODIC_HEAL' 
				or event == 'SPELL_AURA_APPLIED' 
				or event == 'SPELL_AURA_REMOVED'
				or event == 'SPELL_AURA_REFRESH'then
				ignornpcid = true
			end
			if ignornpcid == false then
				UnrealTargets:create_frame(srcnpc_id, srcName, srcGUID)
				if event == "SWING_DAMAGE" then
					local _,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "SPELL_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "RANGE_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "SPELL_PERIODIC_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()--print('add '..event..' '..srcName)
				end
			end
		end
	end
end

function UnrealTargets:create_frame(npc_id, destName, destGUID)
	SendChatMessage(","..npc_id.." -- "..destName, "CHANNEL", nil,  GetChannelName("myaddon"))
	table_insert(unitdb.allunitguids, destGUID)
	unitdb.units[destGUID] = {}
	if unitdb.unitsmaxhp[npc_id] then
		unitdb.units[destGUID].maxhp = unitdb.unitsmaxhp[npc_id].maxhp
	else
		unitdb.units[destGUID].maxhp = 1000000
	end
	unitdb.allframes:Show()
	unitdb.units[destGUID].lastupdate = GetTime()
	unitdb.units[destGUID].debuff = {}
	unitdb.units[destGUID].debuffnumbers = 0
	unitdb.units[destGUID].hp = unitdb.units[destGUID].maxhp
	unitdb.units[destGUID].npcid = npc_id
	unitdb.units[destGUID].bar = CreateFrame("StatusBar", 'bar'..destGUID, unitdb.allframes)
	unitdb.units[destGUID].bar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	unitdb.units[destGUID].bar:SetBackdrop({
		bgFile = "Interface/Buttons/GreyscaleRamp64",
		edgeFile = "Interface/Buttons/WHITE8X8",
		edgeSize = 1,
	});
	unitdb.units[destGUID].bar:SetBackdropBorderColor(1,1,1,1);
	unitdb.units[destGUID].bar:SetBackdropColor(1,1,1,0.2);
	unitdb.units[destGUID].bar:GetStatusBarTexture():SetHorizTile(false)
	unitdb.units[destGUID].bar:SetMinMaxValues(0, 100)
	unitdb.units[destGUID].bar:SetValue(100)
	unitdb.units[destGUID].bar:SetPoint('Topleft', 0, -1*(table_getn(unitdb.allunitguids)-1) * (unrealtargetssettings['config']['rafter_distance']+unrealtargetssettings['config']['height']))
	unitdb.allframes:SetHeight(table_getn(unitdb.allunitguids) * (unrealtargetssettings['config']['rafter_distance']+unrealtargetssettings['config']['height']))
	unitdb.units[destGUID].bar:SetStatusBarColor(unrealtargetssettings['config']['color_r'],
		unrealtargetssettings['config']['color_g'],
		unrealtargetssettings['config']['color_b'])
	unitdb.units[destGUID].bar:SetWidth(unrealtargetssettings['config']['width'])
	unitdb.units[destGUID].bar:SetHeight(unrealtargetssettings['config']['height'])
	unitdb.units[destGUID].fontname = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.units[destGUID].fontname:SetPoint("TOP", 0, -1)
	local targetname = self:cut_name(destName, unrealtargetssettings['config']["barnamecut"])
	unitdb.units[destGUID].fontname:SetText(targetname)
	unitdb.units[destGUID].fontname:SetFont("Fonts\\FRIZQT__.ttf",unrealtargetssettings['config']['height']/3,"OUTLINE")
	unitdb.units[destGUID].fonthppercent = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.units[destGUID].fonthppercent:SetPoint("TOPRIGHT", -1, -1)
	unitdb.units[destGUID].fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",unrealtargetssettings['config']['height']/2,"OUTLINE")
	unitdb.units[destGUID].castbar = CreateFrame("StatusBar", 'castbar'..destGUID, unitdb.units[destGUID].bar)
	unitdb.units[destGUID].castbar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	unitdb.units[destGUID].castbar:SetBackdrop({
		bgFile = "Interface/Buttons/GreyscaleRamp64",
		edgeFile = "Interface/Buttons/WHITE8X8",
		edgeSize = 1,
	});
	unitdb.units[destGUID].castbar:SetBackdropBorderColor(1,1,1,1);
	unitdb.units[destGUID].castbar:SetBackdropColor(1,1,1,0.2);
	unitdb.units[destGUID].castbar:GetStatusBarTexture():SetHorizTile(false)
	unitdb.units[destGUID].castbar:SetMinMaxValues(0, 100)
	unitdb.units[destGUID].castbar:SetValue(100)
	unitdb.units[destGUID].castbar:SetPoint('CENTER', unitdb.units[destGUID].bar, 'CENTER', 0, -unrealtargetssettings['config']['height']/3)
	unitdb.units[destGUID].castbar:SetWidth(unrealtargetssettings['config']['width'])
	unitdb.units[destGUID].castbar:SetHeight(unrealtargetssettings['config']['height']/3)
	unitdb.units[destGUID].castbar:SetStatusBarColor(0,0,0)
	unitdb.units[destGUID].castbar:Hide()
	local castname, _, icon = GetSpellInfo(740)
	unitdb.units[destGUID].icon = unitdb.units[destGUID].bar:CreateTexture(nil, 'ARTWORK')
	unitdb.units[destGUID].icon:SetTexture(GetSpellTexture(740))
	unitdb.units[destGUID].icon:SetWidth(unrealtargetssettings['config']['height'])
	unitdb.units[destGUID].icon:SetHeight(unrealtargetssettings['config']['height'])
	unitdb.units[destGUID].icon:SetPoint("Topleft", -unrealtargetssettings['config']['height'], 0)
	unitdb.units[destGUID].icon:Hide()
	unitdb.units[destGUID].castTime = 0
	unitdb.units[destGUID].castbar_fontname = unitdb.units[destGUID].castbar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.units[destGUID].castbar_fontname:SetPoint("TOPLEFT", 1, -1)
	castname = self:cut_name(castname, unrealtargetssettings['config']["castbarnamecut"] )
	unitdb.units[destGUID].castbar_fontname:SetText(castname)
	unitdb.units[destGUID].castbar_fontname:SetFont("Fonts\\FRIZQT__.ttf", unrealtargetssettings['config']['height']/3-1,"OUTLINE")
	unitdb.units[destGUID].castbartime = unitdb.units[destGUID].castbar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.units[destGUID].castbartime:SetPoint("TOPRIGHT", -1, -1)
	unitdb.units[destGUID].castbartime:SetFont("Fonts\\FRIZQT__.ttf",unrealtargetssettings['config']['height']/3-1,"OUTLINE")
	unitdb.units[destGUID].bordertop = unitdb.units[destGUID].bar:CreateTexture('TOPcolor', 'OVERLAY')
	unitdb.units[destGUID].bordertop:SetColorTexture(0,0,0,0)
	unitdb.units[destGUID].bordertop:SetSize(unrealtargetssettings['config']['width'], 3)
	unitdb.units[destGUID].bordertop:SetPoint('Topleft', 0, 0)
	unitdb.units[destGUID].borderbottom = unitdb.units[destGUID].bar:CreateTexture('BOTTOMcolor', 'OVERLAY')
	unitdb.units[destGUID].borderbottom:SetColorTexture(0,0,0,0)
	unitdb.units[destGUID].borderbottom:SetSize(unrealtargetssettings['config']['width'], 3)
	unitdb.units[destGUID].borderbottom:SetPoint('Bottomleft', 0, 0)
	unitdb.units[destGUID].borderleft= unitdb.units[destGUID].bar:CreateTexture('LEFTcolor', 'OVERLAY')
	unitdb.units[destGUID].borderleft:SetColorTexture(0,0,0,0)
	unitdb.units[destGUID].borderleft:SetSize(3, unrealtargetssettings['config']['height'])
	unitdb.units[destGUID].borderleft:SetPoint('Topleft', 0, 0)
	unitdb.units[destGUID].borderright = unitdb.units[destGUID].bar:CreateTexture('RIGHTcolor', 'OVERLAY')
	unitdb.units[destGUID].borderright:SetColorTexture(0,0,0,0)
	unitdb.units[destGUID].borderright:SetSize(3, unrealtargetssettings['config']['height'])
	unitdb.units[destGUID].borderright:SetPoint('Topright', 0, 0)
end

function UnrealTargets:update_frame_posis()
	for k, unitguid in ipairs(unitdb.allunitguids) do
		unitdb.units[unitguid].bar:SetPoint('Topleft', 0, -1*(k-1) * (unrealtargetssettings['config']['rafter_distance']+unrealtargetssettings['config']['height']))
	end
	unitdb.allframes:SetHeight(table_getn(unitdb.allunitguids) * (unrealtargetssettings['config']['rafter_distance']+unrealtargetssettings['config']['height']))
end

function UnrealTargets:get_spellschool_color_code(colorcode)
	local color = {}
	if colorcode == 1 then
		color.r, color.g ,color.b = 1,1,0
	else
		color.r, color.g ,color.b = 1, 0.1, 0.1
	end
	return color.r, color.g ,color.b
end

function UnrealTargets:cut_name(name, ...)
	local max_length = ... or 15
	local length = string_length(name)
	if length > max_length + 2 then
		name = string_sub(name, 0, max_length)
		name = name..".."
	end
	return name
end

function UnrealTargets:ignor_npc(npc_id)
	for i, unitid in ipairs(unitdb.ignornpc) do
		if tonumber(npc_id) == unitid then
			return true
		end
	end
	return false
end

function UnrealTargets:ignor_buff(spellid)
	for i, unitid in ipairs(unitdb.ignorbuff) do
		if tonumber(spellid) == unitid then
			return true
		end
	end
	return false
end

function UnrealTargets:hp_update(destGUID, dmg)
	dmg = dmg or 0
	unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
	local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
	health = string_format("%.0f", health)
	unitdb.units[destGUID].bar:SetValue(health)
	health = health.."%"
	unitdb.units[destGUID].fonthppercent:SetText(health)
end

function UnrealTargets:npcmaxhp_update()
	local max_health = UnitHealthMax("target")
	local currenthealth = UnitHealth("target")
	if max_health ~= 0 and currenthealth ~= 0 then
		--print("true "..max_health)
		local guid = UnitGUID("target")
		local mytype, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
		if npc_id then
			unitdb.unitsmaxhp[npc_id] = {}
			unitdb.unitsmaxhp[npc_id].maxhp = max_health
			for i, unitguid in ipairs(unitdb.allunitguids) do
				if unitguid == guid then
					unitdb.units[guid].maxhp = max_health
					unitdb.units[guid].hp = currenthealth
					local health = unitdb.units[guid].hp / unitdb.units[guid].maxhp * 100
					health = string_format("%.0f", health)
					unitdb.units[guid].bar:SetValue(health)
					health = health.."%"
					unitdb.units[guid].fonthppercent:SetText(health)
				end
				if npc_id == unitdb.units[unitguid].npcid then
					local deltahp = unitdb.units[unitguid].maxhp - unitdb.units[unitguid].hp 
					unitdb.units[unitguid].maxhp = max_health
					unitdb.units[unitguid].hp = unitdb.units[unitguid].maxhp -deltahp
					self:hp_update(unitguid, 0)
				end		
			end
		end
	end
end

function UnrealTargets:reset_frames()
	for k, unitguid in ipairs(unitdb.allunitguids) do
		unitdb.units[unitguid].bar:Hide()
		unitdb.units[unitguid].castbar:Hide()
		unitdb.units[unitguid] = {}
		table_remove(unitdb.allunitguids, 0)
	end
	unitdb.allunitguids = {}
	unitdb.units = {}
	unitdb.allframes:SetWidth(unrealtargetssettings['config']['width'])
	unitdb.allframes:Hide()
end

function UnrealTargets:isopenworld()
	local mapopenworld = {
		13 -- Kalimdor
		,772 -- Ahn'Qiraj: The Fallen Kingdom
		,894 -- Ammen Vale
		,43	-- Ashenvale
		,181 -- Azshara
		,464 -- Azuremyst Isle
		,476 -- Bloodmyst Isle
		,890 -- Camp Narache
		,42	-- Darkshore
		,381 -- Darnassus
		,101 -- Desolace
		,4 -- Durotar
		,141 --	Dustwallow Marsh
		,891 --	Echo Isles
		,182 --	Felwood
		,121 --	Feralas
		,795 --	Molten Front
		,241 --	Moonglade
		,606 --	Mount Hyjal
		,9 -- Mulgore
		,11	-- Northern Barrens
		,321 --	Orgrimmar
		,888 --	Shadowglen
		,261 --	Silithus
		,607 --	Southern Barrens
		,81	-- Stonetalon Mountains
		,161 --	Tanaris
		,41	-- Teldrassil
		,471 --	The Exodar
		,61	-- Thousand Needles
		,362 --	Thunder Bluff
		,720 --	Uldum
		,201 --	Un'Goro Crater
		,889 --	Valley of Trials
		,281 --	Winterspring
		
		,14	-- Eastern Kingdoms
		,614 --	Abyssal Depths
		,16	-- Arathi Highlands
		,17 -- Badlands
		,19 -- Blasted Lands
		,29	-- Burning Steppes
		,866 --	Coldridge Valley
		,32	-- Deadwind Pass
		,892 --	Deathknell
		,27 -- Dun Morogh
		,34	-- Duskwood
		,23	-- Eastern Plaguelands
		,30	-- Elwynn Forest
		,462 --	Eversong Woods
		,463 --	Ghostlands
		,545 --	Gilneas
		,611 --	Gilneas City
		,24	-- Hillsbrad Foothills
		,341 --	Ironforge
		,499 --	Isle of Quel'Danas
		,610 --	Kelp'thar Forest
		,35	-- Loch Modan
		,895 --	New Tinkertown
		,37	-- Northern Stranglethorn
		,864 --	Northshire
		,36	-- Redridge Mountains
		,684 --	Ruins of Gilneas
		,685 --	Ruins of Gilneas City
		,28 -- Searing Gorge
		,615 --	Shimmering Expanse
		,480 --	Silvermoon City
		,21 -- Silverpine Forest
		,301 --	Stormwind City
		,689 --	Stranglethorn Vale
		,893 --	Sunstrider Isle
		,38	-- Swamp of Sorrows
		,673 --	The Cape of Stranglethorn
		,26	-- The Hinterlands
		,502 --	The Scarlet Enclave
		,20	-- Tirisfal Glades
		,708 --	Tol Barad
		,709 --	Tol Barad Peninsula
		,700 --	Twilight Highlands
		,382 --	Undercity
		,613 --	Vashj'ir
		,22	-- Western Plaguelands
		,39	-- Westfall
		,40 -- Wetlands
		
		,466 --	Outland
		,475 --	Blade's Edge Mountains
		,465 --	Hellfire Peninsula
		,477 --	Nagrand
		,479 --	Netherstorm
		,473 --	Shadowmoon Valley
		,481 --	Shattrath City
		,478 --	Terokkar Forest
		,467 --	Zangarmarsh
		
		,485 --	Northrend
		,486 --	Borean Tundra
		,510 --	Crystalsong Forest
		,504 --	Dalaran
		,488 --	Dragonblight
		,490 --	Grizzly Hills
		,491 --	Howling Fjord
		,541 --	Hrothgar's Landing
		,492 --	Icecrown
		,493 --	Sholazar Basin
		,495 --	The Storm Peaks
		,501 --	Wintergrasp
		,496 --	Zul'Drak
		
		,751 --	The Maelstrom
		,640 --	Deepholm
		,605 --	Kezan
		,544 --	The Lost Isles
		,737 --	The Maelstrom
		
		,862 --	Pandaria
		,858 --	Dread Wastes
		,929 --	Isle of Giants
		,928 --	Isle of Thunder
		,857 --	Krasarang Wilds
		,809 --	Kun-Lai Summit
		,905 --	Shrine of Seven Stars
		,903 --	Shrine of Two Moons
		,806 --	The Jade Forest
		,873 --	The Veiled Stair
		,808 --	The Wandering Isle
		,951 --	Timeless Isle
		,810 --	Townlong Steppes
		,811 --	Vale of Eternal Blossoms
		,807 --	Valley of the Four Winds
		
		,962 --	Draenor
		,978 --	Ashran
		,941 --	Frostfire Ridge
		,976 --	Frostwall
		,949 --	Gorgrond
		,971 --	Lunarfall
		,950 --	Nagrand
		,947 --	Shadowmoon Valley
		,948 --	Spires of Arak
		,1009 -- Stormshield
		,946 --	Talador
		,945 --	Tanaan Jungle
		,970 --	Tanaan Jungle - Assault on the Dark Portal
		,1011 -- Warspear

	}
	local mapID = GetCurrentMapAreaID()
	for _, mapIDdatabase in ipairs(mapopenworld) do
		if mapID == mapIDdatabase then
			print('true')
			return true
		end
	end
	print('false')
	return false
end

function UnrealTargets:raidgrid()
	local numGroupMembers = GetNumGroupMembers()
	unitdb.groupmembers = {}
	unitdb.grouppets = {}
	if IsInRaid() then
		for i = 1 , numGroupMembers do
			table_insert(unitdb.groupmembers, UnitGUID('raid'..i))
			table_insert(unitdb.grouppets, UnitGUID('raidpet'..i))
			table_insert(unitdb.groupids, 'raid'..i)
			--print(grouptype..'guid: '..UnitGUID('raid'..i))
		end
	elseif IsInGroup() then
		for i = 1 , numGroupMembers-1 do
			table_insert(unitdb.groupmembers, UnitGUID('party'..i))
			table_insert(unitdb.grouppets, UnitGUID('partypet'..i))
			table_insert(unitdb.groupids, 'party'..i)
			--print(grouptype..'guid: '..UnitGUID('party'..i))
		end
		table_insert(unitdb.groupmembers, UnitGUID('player'))
		table_insert(unitdb.grouppets, UnitGUID('pet'))
		table_insert(unitdb.groupids, 'player')
	end
	--print('Numbers: '..numGroupMembers)
	if numGroupMembers == 0 then
		table_insert(unitdb.groupmembers, UnitGUID('player'))
		table_insert(unitdb.grouppets, UnitGUID('pet'))
		table_insert(unitdb.groupids, 'player')
		--print('Playerguid: '..UnitGUID('player'))
	end
end

function UnrealTargets:change_zone()
	unitdb.zone = self:isopenworld()
	print('zone change'.. GetCurrentMapAreaID())
end

function UnrealTargets:unit_target(...)
	local arg1 = ... or "player"
	local arg2 = UnitGUID(...) or UnitGUID('player')
	local sourcename = UnitName(arg1)
	local name = UnitName(arg1.."target") or "no target"
	local guid = UnitGUID(arg1..'target') or 'nothing'
	--print(sourcename..": "..name..'  '..arg1..' '..guid)
	--local lasttarget = unitdb.playertargetold[arg1] or nil
	unitdb.playertargetold[arg1] = guid
	--print(guid)
	unitdb.targetnumbers = {}
	for i, groupguid in ipairs(unitdb.groupids) do
		local target = unitdb.playertargetold[groupguid] or 'nothing'
		--print(groupguid..' '..target)
		local isenemy = UnitIsFriend(arg1, arg1.."target")
		for i, friendly in ipairs(unitdb.friendlyunitids) do
			if friendly == arg1 then
				if not isenemy then
					--print("Enemy true "..arg1.."target")
					targetframe[arg1.."target"]:SetBackdropColor(1, 0, 0, 1)
				else
					--print("Enemy false "..arg1.."target")
					targetframe[arg1.."target"]:SetBackdropColor(0.6, 0.6, 0.6, 0.2)
				end
			end
		end
		
		if unitdb.targetnumbers[target] then
			unitdb.targetnumbers[target] = unitdb.targetnumbers[target] + 1 
			-- if unitdb.units[destGUID] then
				-- unitdb.units[destGUID].bar:SetAttribute("unit", groupguid)
			-- end
		else
			--unitdb.targetnumbers[target] = 1
			-- if unitdb.units[destGUID] then
				-- unitdb.units[destGUID].bar:SetAttribute("unit", groupguid)
			-- end
		end
	end
	-- if unitdb.targetnumbers[guid] then
		-- print(guid..' now target from '..unitdb.targetnumbers[guid]..' players')
	-- else
		-- print('target error')
	-- end
	-- self:updateTargets()
end

function UnrealTargets:updateTargets()
	for i, unitguid in ipairs(unitdb.allunitguids) do
		if unitdb.targetnumbers[unitguid] then
			if unitdb.targetnumbers[unitguid] == 1 then
				unitdb.units[unitguid].bordertop:SetColorTexture(1, 0, 0, 1)
				unitdb.units[unitguid].borderbottom:SetColorTexture(1, 0, 0, 1)
				unitdb.units[unitguid].borderleft:SetColorTexture(1, 0, 0, 1)
				unitdb.units[unitguid].borderright:SetColorTexture(1, 0, 0, 1)
			elseif unitdb.targetnumbers[unitguid] == 2 then
				unitdb.units[unitguid].bordertop:SetColorTexture(1, 0.7, 0, 1)
				unitdb.units[unitguid].borderbottom:SetColorTexture(1, 0.7, 0, 1)
				unitdb.units[unitguid].borderleft:SetColorTexture(1, 0.7, 0, 1)
				unitdb.units[unitguid].borderright:SetColorTexture(1, 0.7, 0, 1)
			elseif unitdb.targetnumbers[unitguid] == 3 then
				unitdb.units[unitguid].bordertop:SetColorTexture(1, 1, 0, 1)
				unitdb.units[unitguid].borderbottom:SetColorTexture(1, 1, 0, 1)
				unitdb.units[unitguid].borderleft:SetColorTexture(1, 1, 0, 1)
				unitdb.units[unitguid].borderright:SetColorTexture(1, 1, 0, 1)
			elseif unitdb.targetnumbers[unitguid] >= 4 then
				unitdb.units[unitguid].bordertop:SetColorTexture(0, 1, 0, 1)
				unitdb.units[unitguid].borderbottom:SetColorTexture(0, 1, 0, 1)
				unitdb.units[unitguid].borderleft:SetColorTexture(0, 1, 0, 1)
				unitdb.units[unitguid].borderright:SetColorTexture(0, 1, 0, 1)
			end
		else
			unitdb.units[unitguid].bordertop:SetColorTexture(0,0,0,0)
			unitdb.units[unitguid].borderbottom:SetColorTexture(0,0,0,0)
			unitdb.units[unitguid].borderleft:SetColorTexture(0,0,0,0)
			unitdb.units[unitguid].borderright:SetColorTexture(0,0,0,0)
		end
	end
end

function UnrealTargets:player_target(...)
	local arg1 = ... or 'player'
	if arg1 == 'player' then
		local guid = UnitGUID(arg1..'target')
		if guid then
			unitdb.playertarget = guid
		else
			unitdb.playertarget = 'nil'
			self:update_unit_grid()
		end
	end
end

function UnrealTargets:mouseover_target(...)
	local arg1 = ... or 'player'
	if arg1 == 'player' then
		local guid = UnitGUID('mouseover')
		if guid then
			unitdb.playermouseover = guid
		else
			unitdb.playermouseover = 'nil'
			self:update_unit_grid()
		end
	end
end

function UnrealTargets:focus_target(...)
	local arg1 = ... or 'player'
	if arg1 == 'player' then
		local guid = UnitGUID('focus')
		if guid then
			unitdb.playerfocus = guid
		else
			unitdb.playerfocus = 'nil'
			self:update_unit_grid()
		end
	end
end

function UnrealTargets:update_unit_grid()
	local targetunits = {}
	if unitdb.playerfocus ~= 'nil' and unitdb.units[unitdb.playerfocus] then
		unitdb.units[unitdb.playerfocus].bordertop:SetColorTexture(1, 0.5, 0, 1)
		unitdb.units[unitdb.playerfocus].borderbottom:SetColorTexture(1, 0.5, 0, 1)
		unitdb.units[unitdb.playerfocus].borderleft:SetColorTexture(1, 0.5, 0, 1)
		unitdb.units[unitdb.playerfocus].borderright:SetColorTexture(1, 0.5, 0, 1)
		table_insert(targetunits, unitdb.playerfocus)
	end
	if unitdb.playertarget ~= 'nil' and unitdb.units[unitdb.playertarget] then
		unitdb.units[unitdb.playertarget].bordertop:SetColorTexture(0, 1, 0, 1)
		unitdb.units[unitdb.playertarget].borderbottom:SetColorTexture(0, 1, 0, 1)
		unitdb.units[unitdb.playertarget].borderleft:SetColorTexture(0, 1, 0, 1)
		unitdb.units[unitdb.playertarget].borderright:SetColorTexture(0, 1, 0, 1)
		table_insert(targetunits, unitdb.playertarget)
	end
	if unitdb.playermouseover ~= 'nil' and unitdb.units[unitdb.playermouseover] and unitdb.playermouseover == unitdb.playertarget  then
		unitdb.units[unitdb.playermouseover].bordertop:SetColorTexture(0, 0.44, 0.87, 1)
		unitdb.units[unitdb.playermouseover].borderbottom:SetColorTexture(0, 0.44, 0.87, 1)
		--unitdb.units[unitdb.playermouseover].borderleft:SetColorTexture(0, 0.44, 0.87, 1)
		--unitdb.units[unitdb.playermouseover].borderright:SetColorTexture(0, 0.44, 0.87, 1)
		table_insert(targetunits, unitdb.playermouseover)
	elseif unitdb.playermouseover ~= 'nil' and unitdb.units[unitdb.playermouseover] then
		unitdb.units[unitdb.playermouseover].bordertop:SetColorTexture(0, 0.44, 0.87, 1)
		unitdb.units[unitdb.playermouseover].borderbottom:SetColorTexture(0, 0.44, 0.87, 1)
		unitdb.units[unitdb.playermouseover].borderleft:SetColorTexture(0, 0.44, 0.87, 1)
		unitdb.units[unitdb.playermouseover].borderright:SetColorTexture(0, 0.44, 0.87, 1)
		table_insert(targetunits, unitdb.playermouseover)
	end
	
	local iscolored = false
	for i, allgroupguid in ipairs(unitdb.allunitguids) do
		for j, istarget in ipairs(targetunits) do
			if allgroupguid == istarget then
				iscolored = true
			end
		end
		if not iscolored then
			unitdb.units[allgroupguid].bordertop:SetColorTexture(0,0,0,0)
			unitdb.units[allgroupguid].borderbottom:SetColorTexture(0,0,0,0)
			unitdb.units[allgroupguid].borderleft:SetColorTexture(0,0,0,0)
			unitdb.units[allgroupguid].borderright:SetColorTexture(0,0,0,0)
		end
		iscolored = false
	end
end


function UnrealTargets:spelltest(_, event,hide,srcGUID,srcName,srcF1,srcF2,destGUID,destName, ...)
	--if event == 'SPELL_CAST_START' or event == 'SPELL_CAST_SUCCESS' or event == 'SPELL_AURA_APPLIED' then
		local _, _, spellID, spellname, spellSchool = ... or 0,0,0,'',0
		if spellID then
			local _, _, _, thecasttime = GetSpellInfo(spellID) or 0,0,0,0
			print(event..' '..spellname..'('..spellID..') '..thecasttime)
		end
	--end
end

UnrealTargets:SetScript("OnUpdate", function(self, frame) 
	-- if myunits.castTime ~= 0 then
		-- local value = myunits.castTimeend - GetTime()
		-- if value >= 0 then
			-- local value2 = value/myunits.castTime
			-- myunits.castbar:SetValue((1-value2)*100)
			-- --print(value2)
		-- else
			-- myunits.castTime = 0
			-- myunits.castbar:Hide()
			-- myunits.icon:Hide()
		-- end
	-- end
	local localtime = GetTime()
	for i, unitguid in ipairs(unitdb.allunitguids) do
		if unitdb.units[unitguid].castTime ~= 0 then
			local remaining_time = unitdb.units[unitguid].castTimeend - localtime
			if remaining_time >= 0 then
				if unitdb.units[unitguid].castinterrupt == false then
					local value2 = remaining_time/unitdb.units[unitguid].castTime
					unitdb.units[unitguid].castbar:SetValue((1-value2)*100)
					unitdb.units[unitguid].castbar:Show()
					unitdb.units[unitguid].icon:Show()
					remaining_time = string_format("%.1f", remaining_time)
					unitdb.units[unitguid].castbartime:SetText(remaining_time)				
				end
			else
				unitdb.units[unitguid].castinterrupt = false
				unitdb.units[unitguid].castTime = 0
				unitdb.units[unitguid].castbar:Hide()
				unitdb.units[unitguid].icon:Hide()
			end
		end
		if unitdb.units[unitguid].lastupdate + 10 < localtime then
			for i, destGUID in ipairs(unitdb.allunitguids) do
				if destGUID == unitguid then
					table_remove(unitdb.allunitguids, i)
					unitdb.units[unitguid].bar:Hide()
					unitdb.units[unitguid].castbar:Hide()
					self:update_frame_posis()
				end
			end
		end
	end
	for i, spellnameplusGUID in ipairs(unitdb.playerdebuffs) do
		local spname, dGUID = strsplit('|', spellnameplusGUID)
		if unitdb.units[dGUID] then
			if unitdb.units[dGUID].debuff[spname] then
				if unitdb.units[dGUID].debuff[spname].expirationTime then
					local remaining_time = unitdb.units[dGUID].debuff[spname].expirationTime - localtime
					remaining_time = string_format("%.0f", remaining_time)
					unitdb.units[dGUID].debuff[spname].fontduration:SetText(remaining_time)
				end
			end
		end
	end
	
	self:update_unit_grid()
	--collectgarbage()
	--ResetCPUUsage()
end)

function UnrealTargets:OnEvent(event, ...)
	if event == 'PLAYER_LOGIN' then
		self:Initialize(...)
	elseif event == 'COMBAT_LOG_EVENT_UNFILTERED' then
		self:frame_update(...)
		--self:spelltest(...)
	elseif event == 'PLAYER_TARGET_CHANGED' then
		self:npcmaxhp_update()
	elseif event == 'ENCOUNTER_END' then
		self:reset_frames()
		unitdb.isinfight = false
	elseif event == 'PLAYER_REGEN_ENABLED' then
		self:reset_frames()
		unitdb.isinfight = false
	elseif event == 'ENCOUNTER_START' then
		unitdb.isinfight = true
	elseif event == 'PLAYER_REGEN_DISABLED' then
		unitdb.isinfight = true
	elseif event == 'ADDON_LOADED' then
		self:mysettings(...)
		--self:change_zone()
		--self:change_zone()
	elseif event == 'UNIT_HEALTH_FREQUENT' then
		self:frequently_frame_update(...)
	elseif event == 'GROUP_ROSTER_UPDATE' then
		self:raidgrid()	
	--elseif event == 'ZONE_CHANGED_NEW_AREA' then
		--self:change_zone()
	elseif event == 'UNIT_TARGET' then
		self:unit_target(...)
		self:player_target(...)
		--print('target changed')
	elseif event == 'UPDATE_MOUSEOVER_UNIT' then
		--print('mouseover changed')
		self:mouseover_target(...)
	elseif event == 'PLAYER_FOCUS_CHANGED' then
		self:focus_target(...)
		--print('focus changed')
	-- elseif event == 'UPDATE_MOUSEOVER_UNIT' then
		-- self:unit_mouseover(...)
	end
	return
end

function OnEvent(self, event, ...)
	UnrealTargets:OnEvent(event, ...)
end



UnrealTargets:RegisterEvent('GROUP_ROSTER_UPDATE')
UnrealTargets:RegisterEvent('PLAYER_LOGIN')
UnrealTargets:RegisterEvent('UNIT_HEALTH_FREQUENT')
UnrealTargets:RegisterEvent('PLAYER_TARGET_CHANGED')
UnrealTargets:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED');
UnrealTargets:RegisterEvent('ENCOUNTER_END')
UnrealTargets:RegisterEvent('PLAYER_REGEN_ENABLED')
UnrealTargets:RegisterEvent('ENCOUNTER_START')
UnrealTargets:RegisterEvent('ADDON_LOADED')
--UnrealTargets:RegisterEvent('ZONE_CHANGED_NEW_AREA')
UnrealTargets:RegisterEvent('UNIT_TARGET')
UnrealTargets:RegisterEvent('UPDATE_MOUSEOVER_UNIT')
UnrealTargets:RegisterEvent('PLAYER_FOCUS_CHANGED')
--UnrealTargets:RegisterEvent('UPDATE_MOUSEOVER_UNIT')
UnrealTargets:RegisterEvent('PLAYER_REGEN_DISABLED')
UnrealTargets:RegisterEvent('GROUP_ROSTER_UPDATE')
UnrealTargets:SetScript('OnEvent', OnEvent)



